#ifndef _TEST_APP
#define _TEST_APP

// uncomment this for OF 007 compatibility
//#define OFX_OPENNI_BETA

#include "ofMain.h"
#include "ofxOpenNI.h"
#include "ofxNetwork.h"
#include "ofxVectorMath.h"
#include "ofxBox2d.h"
#include "ofxImage.h"

struct client {
	ofPoint pos;
	int radius;
	int action;
	int color;
	bool drawn;
};

// ------------------------------------------------- a simple extended box2d circle
class CustomParticle : public ofxBox2dCircle {
	
public:
	CustomParticle() {
	}
	ofColor color;
	void draw() {
		float radius = getRadius();
		
		glPushMatrix();
		glTranslatef(getPosition().x, getPosition().y, 0);
		
		ofSetColor(color.r, color.g, color.b);
		ofFill();
		ofCircle(0, 0, radius);	
		
		glPopMatrix();
		
	}
};

class testApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed  (int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		void drawUsers();
		void drawOpenGLStuff();
		void drawCursor();
		void drawBox2D();
		void parseString();
		void skeletonsToFlash();
		string limbToFlash(int i, string address, ofxLimb &limb);
		void updateFlash();
		void drawUserDots(int i, ofxTrackedUser *skeleton);
		void drawLimb(string uid, string l, ofxLimb &limb);
		void updateSocket();
		string deviceId;
		ofxOpenNIContext context;
		ofxImageGenerator rgbimage;
		ofxImage flippedimage;
		ofxDepthGenerator depth;
		ofxUserGenerator user;
		std::vector<string>	msg_strings;
	
		ofxTCPClient tcpClient;
		string msgTx, msgRx;
		int connectTime;
		int deltaTime;
		map <string, client>clients;
		map <string, client>::iterator it;
		map <string, bool> skeletonsDrawn;
		
		string lastClient;
		
		bool weConnected;
		ofTrueTypeFont  monosm;
	
	// box2d
	// mga
	map <string, ofxBox2dCircle>	userDots;
	map <string, ofxBox2dJoint>		userJoints;
	// common
	float px, py;
	bool							bDrawLines;
	bool							bMouseForce;
	
	ofxBox2d						box2d;			  //	the box2d world
	vector		<ofxBox2dCircle>	circles;		  //	default box2d circles
	vector		<ofxBox2dPolygon>	polygons;		  //	defalut box2d polgons
	vector		<ofxBox2dRect>		boxes;			  //	defalut box2d rects
	vector      <ofxBox2dLine>		lines;			  //	default box2d lines (hacked)
	vector		<CustomParticle>	customParticles;  //	this is a custom particle the extends a cirlce
	
	ofxBox2dLine					lineStrip;		  //	a linestrip for drawing
};

#endif
